.\" gd_nframes.3.  The gd_nframes man page.
.\"
.\" Copyright (C) 2008, 2010, 2011, 2014 D. V. Wiebe
.\"
.\""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
.\"
.\" This file is part of the GetData project.
.\"
.\" Permission is granted to copy, distribute and/or modify this document
.\" under the terms of the GNU Free Documentation License, Version 1.2 or
.\" any later version published by the Free Software Foundation; with no
.\" Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
.\" Texts.  A copy of the license is included in the `COPYING.DOC' file
.\" as part of this distribution.
.\"
.TH gd_nframes 3 "16 October 2014" "Version 0.9.0" "GETDATA"
.SH NAME
gd_nframes \(em report the size of a dirfile
.SH SYNOPSIS
.B #include <getdata.h>
.HP
.nh
.ad l
.BI "off_t gd_nframes(DIRFILE *" dirfile );
.hy
.ad n
.SH DESCRIPTION
The
.BR gd_nframes ()
function queries a dirfile(5) database specified by
.I dirfile
and returns the number of frames in the database.  Since different fields may
have differing number of frames, the Dirfile Standards (see
.BR dirfile (5))
dictate that the number of frames in the database is defined to be equal to the
number of frames in the reference field defined by the
.B /REFERENCE
directive (see
.BR dirfile-format (5))
or, if no such reference field is defined, by the first raw field specified in
the format specification.

If no vector fields are defined in the database,
.BR gd_nframes ()
returns zero and succeeds.

The 
.I dirfile
argument must point to a valid DIRFILE object previously created by a call to
.BR gd_open (3).

.SH RETURN VALUE
Upon successful completion,
.BR gd_nframes ()
returns the number of frames in the dirfile.  On error, it returns zero and sets
the dirfile error to a non-zero error value.  Possible error values are:
.TP 8
.B GD_E_ALLOC
The library was unable to allocate memory.
.TP
.B GD_E_BAD_DIRFILE
The supplied dirfile was invalid.
.TP
.B GD_E_IO
An attempt to determine the (unencoded) size of the data file associated with
the reference field failed.
.TP
.B GD_E_UNKNOWN_ENCODING
The size of the decoded data file associated with the reference field could not
be not be determined because its encoding was not understood.
.TP
.B GD_E_UNSUPPORTED
The size of the decoded data file associated with the reference field could not
be not be determined because its encoding was not supported.
.PP
The dirfile error may be retrieved by calling
.BR gd_error (3).
A descriptive error string for the last error encountered can be obtained from
a call to
.BR gd_error_string (3).
.SH SEE ALSO
.BR dirfile (5),
.BR dirfile-encoding (5),
.BR gd_open (3),
.BR gd_bof (3),
.BR gd_eof (3),
.BR gd_error (3),
.BR gd_error_string (3)
